/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Main.java to edit this template
 */
package tareacenafilosofos;

import java.sql.Timestamp;
import java.util.Arrays;
import java.util.Scanner;
import java.util.concurrent.Semaphore;
import java.util.concurrent.TimeUnit;

/**
 *
 * @author kyman
 */
public class TareaCenaFilosofos {
    
    // Configuración.
    private static final int numero_de_filosofos = 5;
    private static final int tiempo_minimo_de_espera = 10; // Milisegundos
    private static final int tiempo_de_pensar = 10; // Segundos
    private static final int tiempo_para_comer = 2; // Segundos
    private static final int tiempo_limite_para_palillo = 100; // Milisegundos
    // Configuración.
    
    private static boolean trabajando = true;
    private static Semaphore[] palillos;

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        
        palillos = new Semaphore[numero_de_filosofos];
        
        new Thread(new Runnable(){
            @Override
            public void run() {
                
                Scanner entrada = new Scanner(System.in);
                String comando;
                
                while(trabajando && (comando = entrada.nextLine()) != null){
                    switch(comando){
                        case "exit", "close", "cerrar", "terminar", "bye", "detener", "finalizar", "stop" -> trabajando = false;
                        default -> System.out.println("Comando '" + comando + "' desconocido.");
                    }
                }
                
            }
        }).start();
        
        for(int i = 0; i < numero_de_filosofos; i ++)
            palillos[i] = new Semaphore(1);
        for(int i = 0; i < numero_de_filosofos; i ++)
            crear_filosofo(i);
        
    }
    
    public static void excepcion(Exception exception){
        System.out.println(exception.getMessage());
        System.out.println(Arrays.toString(exception.getStackTrace()));
    }
    
    private static long coger_milisegundos(){
        return new Timestamp(System.currentTimeMillis()).getTime();
    }
    
    private static boolean esperar(float segundos){
        
        boolean continua = true;
        float espera = (float) (Math.random() * segundos * 1000);
        long inicio = coger_milisegundos();
        
        try {
            do{
                if(trabajando)
                    Thread.sleep(tiempo_minimo_de_espera);
                else{
                    continua = false;
                    break;
                }
            }while(coger_milisegundos() - inicio < espera);
        } catch (InterruptedException excepcion) {
            TareaCenaFilosofos.excepcion(excepcion);
        }
        
        return continua && trabajando;
    }
    
    private static void crear_filosofo(int i){
        
        Semaphore[] mis_palillos = {palillos[i], palillos[(i + 1) % numero_de_filosofos]};
        
        new Thread(new Runnable() {
            @Override
            @SuppressWarnings("empty-statement")
            public void run() {
                try {
                    while(trabajando){

                        System.out.println("El filosofo '" + i + "' está pensando...");
                        if(!esperar(tiempo_de_pensar))break;

                        System.out.println("El filosofo '" + i + "' tiene hambre...");
                        while(
                            !mis_palillos[0].tryAcquire(tiempo_limite_para_palillo, TimeUnit.MILLISECONDS) || 
                            !mis_palillos[1].tryAcquire(tiempo_limite_para_palillo, TimeUnit.MILLISECONDS)
                        )
                            if(!trabajando)
                                return;

                        System.out.println("El filosofo '" + i + "' está comiendo...");
                        if(!esperar(tiempo_para_comer))break;
                        mis_palillos[0].release();
                        mis_palillos[1].release();

                    }
                } catch (InterruptedException excepcion) {
                    TareaCenaFilosofos.excepcion(excepcion);
                }
            }
        }).start();
    }
    
}
